"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const node_forge_1 = __importDefault(require("node-forge"));
const react_native_modpow_1 = __importDefault(require("react-native-modpow"));
const expo_random_1 = require("expo-random");
// native-modpow to accelerate RSA encryption
node_forge_1.default.jsbn.BigInteger.prototype.modPow = function nativeModPow(e, m) {
    const result = (0, react_native_modpow_1.default)({
        target: this.toString(16),
        value: e.toString(16),
        modifier: m.toString(16)
    });
    return new node_forge_1.default.jsbn.BigInteger(result, 16);
};
// proper entropy for forge's prng
node_forge_1.default.random.collect(Buffer.from((0, expo_random_1.getRandomBytes)(1024)).toString('binary'));
node_forge_1.default.random.seedFileSync = function (needed) {
    return Buffer.from((0, expo_random_1.getRandomBytes)(needed)).toString('binary');
};
node_forge_1.default.random.seedFile = async function (needed, callback) {
    callback(null, Buffer.from(await (0, expo_random_1.getRandomBytesAsync)(needed)).toString('binary'));
};
// necessary for joi, through https://github.com/sideway/address
global.TextEncoder = class TextEncoder {
    constructor() {
        this.encoding = 'utf-8';
    }
    encode(s) {
        return Buffer.from(s, 'utf-8'); // buffer is a subclass of UInt8Array
    }
    encodeInto(s, uint8Array) {
        throw new Error('Not implemented');
    }
};
//# sourceMappingURL=patches.js.map